<script>
  export let route
  export let title
  export let extraFn

  import { Refresh, FileAdd } from '../../assets/icons'
  import StudyingIllustration from '../../assets/studying.svg'

  import { onDestroy } from 'svelte'
  import localForage from 'localforage'

  import LoadingBox from '../../components/LoadingBox'
  import Homework from '../../components/Homework'
  import Error from '../../components/Error'
  import ModalMenu from './ModalMenu'

  import groups from '../../stores/groups'
  import homeworks from '../../stores/homeworks'
  import offline from '../../stores/offline'

  import getGroupAuth from '../../utils/getGroupAuth'
  import { categorizeHomeworks } from './utils'

  import { getGroup } from '../../api/groups'

  let auth

  let loading = true
  let error
  $: groupId = parseInt(route.matches[1])
  $: group = $groups[groupId]
  $: $title = group ? group.name : 'Grupo'
  $: groupHomeworks = Object.values($homeworks)
    .filter(({ group_id }) => groupId == group_id)
    .sort((a, b) => new Date(a.deadline_date) - new Date(b.deadline_date))
  $: activeHomeworks = groupHomeworks.filter(({ archived }) => !archived)

  let archivedHomeworks = []
  let categories = {}
  $: {
    ;[archivedHomeworks, categories] = categorizeHomeworks(groupHomeworks)
  }

  $: refresh(groupId)

  let refreshKey = 0

  function refresh() {
    loading = true
    error = null
    refreshKey++
    getGroupAuth(groupId)
      .then(_auth => (auth = _auth))
      .then(auth => getGroup(auth.id, auth.secret))
      .catch(e => (error = e))
      .finally(() => (loading = false))
  }

  const interval = setInterval(refresh, 5 * 60 * 1000)
  onDestroy(() => clearInterval(interval))

  let overlayEnabled = false
  $extraFn = e => (overlayEnabled = true)
</script>

{#if overlayEnabled}
  <ModalMenu closeFn={e => (overlayEnabled = false)} {group} {auth} />
{/if}

{#if group}
  <div class="max-w-xl w-full m-auto px-3">
    <div class="flex flex-wrap justify-center mb-1 mt-3">
      <button
        class="btn btn-outlined mx-1 my-1"
        disabled={$offline || loading || null}
        on:click={refresh}
      >
        <span class="icon mr-2">
          <Refresh />
        </span>
        Refrescar
      </button>
      <a
        class="btn btn-outlined mx-1 my-1"
        disabled={$offline || null}
        href={`#/groups/${groupId}/homeworks/create`}
      >
        <span class="icon mr-2">
          <FileAdd />
        </span>
        Crear tarea
      </a>
    </div>
    <div class={loading ? 'pointer-events-none opacity-75' : ''}>
      <!-- content -->
      {#if error === 'network_error'}
        <Error className="m-2">
          {#if $offline}
            Estás sin internet.
          {:else}Hubo un problema conectandose a nuestros servidores.{/if}
          La información puede estar desactualizada.
        </Error>
      {:else if error === 'not_found'}
        <Error className="m-2">
          Por alguna razón desconocida, el servidor no reconoce este grupo. Es
          posible que haya un problema temporal. La información puede estar
          desactualizada.
        </Error>
      {:else if error}
        <Error className="m-2" {error} />
      {/if}
      {#if archivedHomeworks.length > 0}
        <details
          class="shadow-inner bg-gray-200 dark:bg-gray-800 rounded mb-4 px-4 py-2"
          open={false}
        >
          <summary
            class="p-2 text-lg leading-tight cursor-pointer focus:outline-none
            focus:shadow-outline"
          >
            Tareas borradas (se eliminan definitivamente después de una semana)
          </summary>
          {#each archivedHomeworks as homework (homework.id)}
            <Homework {homework} {auth} showDeadline={true} {refreshKey} />
          {/each}
        </details>
      {/if}
      {#each Object.entries(categories) as [name, { homeworks, showDeadline }]}
        {#if homeworks.length > 0}
          <h3 class="text-2xl font-bold pt-3">{name}</h3>
          {#each homeworks as homework (homework.id)}
            <Homework {homework} {auth} {showDeadline} {refreshKey} />
          {/each}
        {/if}
      {/each}
      {#if activeHomeworks.length < 1}
        <p class="text-center p-2 text-lg">
          <StudyingIllustration
            props={{ class: 'max-w-sm mx-auto mt-2 mb-6' }}
          />
          No hay tareas activas en este grupo.
          <a class="link" href={`#/groups/${groupId}/homeworks/create`}>
            ¿Querés crear una?
          </a>
        </p>
      {/if}
    </div>
  </div>
{:else if loading}
  <LoadingBox />
{/if}

{#if !group && error}
  <div class="p-2 m-auto m-full max-w-lg">
    {#if error === 'network_error'}
      <p>
        Hubo un problema conectandose a nuestros servidores y no se guardo el
        grupo cuando estaba en línea. Volve a conectarte a internet o probá más
        tarde.
      </p>
    {:else}
      <Error {error} />
    {/if}
    <div class="p-2">
      <p class="p-2 text-center">Se volvera a intentar en 30 segundos.</p>
      <button class="btn btn-blue m-auto block" on:click={refresh}>
        Reintentar ahora
      </button>
    </div>
  </div>
{/if}
